'use strict';



var VacunasApp = angular.module('vacunasApp', ['ngCordova','ngRoute']);


VacunasApp.run(function ($rootScope, $http, $cordovaPush, $document) {
	//código que se ejecuta justo cuando arranca la app
	$rootScope.showMenuButton = false;
	$rootScope.activePageType = "";
	$rootScope.campanaNotificacion = angular.element(document.querySelector('#campana'));
	$rootScope.numero = angular.element(document.querySelector('#numeroNotficacion'));
	numeroNotficacion

     //$rootScope.app = "EB4A6541-75AF-4EB6-9DEB-2CBFF3A5CD0D";
	$rootScope.app = "6E114697-885D-414E-B515-3F034827E546"; //GUID de Vacunas AMV BD Panamericana.dbo.APPs
	$rootScope.Pais = null;

    var onSuccess = function (position) {
                 
                $rootScope.LatApp = position.coords.latitude;
                $rootScope.LonApp = position.coords.longitude;
                $http.get('https://maps.googleapis.com/maps/api/geocode/json?latlng=' + $rootScope.LatApp + ',' + $rootScope.LonApp)
                 .success(function (data) {
                          var comp = data.results[0].address_components;
                          for (var i = 0; i < comp.length; i++) {
                          var s = comp[i].types[0];
                          if (s == "country") {
                          
                          $rootScope.Pais = comp[i].short_name;
                          
                          }//FIN IF
                          
                          }//FIN FOR
                          
                          //REGISTRO DEVICE                        
                          var tokenIOS = $rootScope.TokenDevice;
                          var plataforma = "ANDROID";
                          var filial = $rootScope.Pais;
                          var url = 'http://notificacionespana.binpar.com/api/NotificacionesCota/AppsDeviceNotifications?token=' + tokenIOS + '&plat=' + plataforma + '&app=' + $rootScope.app + '&filial=' + filial;
                          
                          $http.get(url)
                         .success(function (dato) {                               
                            // alert(dato);
                           }).error(function (e) {
                              // alert(e);
                             });                          
                          });//fin success Fin Google                 
                }//FIN ONSUCCESS                 
                 // onError Callback receives a PositionError object
                 //
                 function onError(error) {
                 //alert('code: ' + error.code + '\n' +'message: ' + error.message + '\n');
                 }                 
                 var NuevaNotificacion = function () {
                     $rootScope.campanaNotificacion.css('opacity', '1');
                     $rootScope.numero.css('opacity', '1');                    

                 }
              
                 
                 
                 
    //Código notificaciones
    var androidConfig = {
        "senderID": "895974359699"
    };


    $cordovaPush.register(androidConfig).then(function (result) {

    }, function (err) {

    });


    $rootScope.$on('$cordovaPush:notificationReceived', function (event, notification) {

        handleAndroidPush(notification);

    });

    //FAUSTO
    function handleAndroidPush(notification) {
        switch (notification.event) {
            case 'registered':
                if (notification.regid.length > 0) {
                    $rootScope.TokenDevice = notification.regid;                   
                    //alert("EL TOKEN " + notification.regid);
                    //REGISTRO DEL DISPOSITIVO EN BD CON EL TOKEN PARA LAS NOT PUSH
                    //***************************************************************************
                    //***************************************************************************
                    //************** MODIFICAR EN IOS ESTO, PASAR LA FUNCION DEL REGISTRO *******
                    //************** a la funcion onSuccess *************************************
                    //***************************************************************************

                   navigator.geolocation.getCurrentPosition(onSuccess, onError);
                }

                break;

            case 'message':               
                $rootScope.NotificacionArrived = notification.payload;
                NuevaNotificacion();
                break;

            case 'error':
                console.log('GCM error = ' + notification.msg);
                break;

            default:
                console.log('An unknown GCM event has occurred');
                break;
        }    
    }//FAUSTO           
              
     
                 
	//back function
	$rootScope.$back = function () {
		window.history.back();
	};
});





VacunasApp.controller('MainController', ['$scope', '$rootScope', '$http', '$document', '$cordovaDialogs',
  function ($scope, $rootScope, $http, $document, $cordovaDialogs) {

      var divNewNotification = angular.element(document.querySelector('#NuevaNotificacion'));
      var contentCover = angular.element(document.querySelector('.contentCover'));
      var divNotificaciones = angular.element(document.querySelector('#divNotificaciones'));
      
      $scope.verNotificaciones = function () {

          $rootScope.campanaNotificacion.css('opacity', '0.6');
          $rootScope.numero.css('opacity', '0');

          contentCover.css('display', 'none');
          divNotificaciones.css('display', 'block');



          if ($rootScope.NotificacionArrived) {
              $scope.NotifPush = {
                  id: $rootScope.NotificacionArrived.ID,
                  Title: $rootScope.NotificacionArrived.title,
                  Text: $rootScope.NotificacionArrived.message,
                  MensajeCorto: $rootScope.NotificacionArrived.message.substring(0, 15) + " [...]",
                  Date: $rootScope.NotificacionArrived.time,
                  Enlace: $rootScope.NotificacionArrived.link,
                  //id: $rootScope.NotificacionArrived.ID,
                  //Title: $rootScope.NotificacionArrived.title,
                  //Text: $rootScope.NotificacionArrived.body,
                  //MensajeCorto: $rootScope.NotificacionArrived.body.substring(0, 15) + " [...]",
                  //Date: $rootScope.NotificacionArrived.fecha,
                  //Enlace: $rootScope.NotificacionArrived.enlace,
              }
              divNewNotification.css('display', 'block');
          }







      }

      $scope.ocultarNotificaciones = function () {
          contentCover.css('display', 'block');
          divNotificaciones.css('display', 'none');
      }







      $scope.AllNotifications = [];
     
      //$http.get('http://localhost:65275/api/NotificacionesCota/getNotificacionesAppPana?app=' + $rootScope.app + '').success(function (data) {
      $http.get('http://notificacionespana.binpar.com/api/NotificacionesCota/getNotificacionesAppPana?app=' + $rootScope.app + '')
             .success(function (data) {
                 if (data.length > 0) {
                     $scope.NoMessages = false;
                     for (var i = 0; i < data.length; i++) {
                         var APP = "COTA-" + data[i].id;
                         var vistas = window.localStorage.getItem(APP);
                         if (vistas) {
                             var notificacion = {
                                 Numero: i,
                                 id: data[i].id,
                                 Title: data[i].Title,
                                 Text: data[i].Text,
                                 MensajeCorto: data[i].Text.substring(0, 8) + " [...]",
                                 Date: data[i].Date,
                                 Enlace: data[i].Enlace,
                                 Vista: true
                             }

                             $scope.AllNotifications.push(notificacion);
                         } else {
                             var notificacion = {
                                 Numero: i,
                                 id: data[i].id,
                                 Title: data[i].Title,
                                 Text: data[i].Text,
                                 MensajeCorto: data[i].Text.substring(0, 8) + " [...]",
                                 Date: data[i].Date,
                                 Enlace: data[i].Enlace,
                                 Vista: false
                             }
                             $scope.AllNotifications.push(notificacion);
                         }

                     }

                 } else {
                     $scope.NoMessages = true;
                 }

             }).error(function (e) { });


      //Guarda notificacion vista
      $scope.SaveCheckNotification = function (notificacionCheck, vista, numero) {

          var ID = notificacionCheck.id;
          var App = $rootScope.app;
          var OS = "ANDROID";
          var Fecha = notificacionCheck.Date;


          //Envio los datos al servidor
          //$http.get('http://localhost:65275/api/NotificacionesCota/SaveCheckNotification?idNotification=' + ID + '&app=' + App + '&OS=' + OS + '&fecha=' + Fecha + '').success(function (data) {
          $http.get('http://notificacionespana.binpar.com/api/NotificacionesCota/SaveCheckNotification?idNotification=' + ID + '&app=' + App + '&OS=' + OS + '&fecha=' + Fecha + '')
                    .success(function (data) {
                        var d = data;
                    }).error(function (e) {
                        var m = e;
                    });
          if (notificacionCheck.Enlace == "") {
              $cordovaDialogs.alert(notificacionCheck.Text, notificacionCheck.Title, 'Aceptar');
          } else {
       
              $cordovaDialogs.confirm(notificacionCheck.Text, notificacionCheck.Title, ['Cerrar', 'Ver enlace'])
                                  .then(function (boton) {
                                      if (boton == 2) {

                                          window.open(notificacionCheck.Enlace, '_system', 'location=yes');
                                      }

                                  });


          }//Fin else

          $scope.NotificacionVista(ID, vista, numero);

      }//Fin guardar notificacion vista



      //Guardar en localstorage
      $scope.NotificacionVista = function (id, nueva, numero) {
          var APP = "COTA-" + id;
          window.localStorage.setItem(APP, "VISTA");

          if (nueva) {
              //alert('Nueva');
              $scope.NotifPush = {};
              divNewNotification.css('display', 'none');
          } else {
              //alert('Vieja');
              var idNoti = "#Noti" + numero.toString();
              var divNotification = angular.element(document.querySelector(idNoti));
              divNotification.removeClass("notificacionNoVista");
              divNotification.addClass("notificacionVista");
          }



      }



  }]);


